function [id_set] = extract_data(data_set)
%Function to extract useful data
%   This function extracts desired data from a dataset generated from
%   Aanestads simulator and saves it in a new dataset, id_set. 
load(data_set)

% choke_pressure = choke_sim;
% pipe_pressure_sim_delta = pipe_pressure_sim;
% dh_pressure_sim_delta = dh_pressure_sim;


lengths = [length(choke_pressure.data) length(piston_velocity_ref.data) ...
    length(pipe_pressure_sim_delta.data) length(dh_pressure_sim_delta.data)];
min_length = min(lengths);

id_set = [choke_pressure.data(1:min_length) ...
    piston_velocity_ref.data(1:min_length) ...
    pipe_pressure_sim_delta.data(1:min_length,:) ...
    dh_pressure_sim_delta.data(1:min_length)];
end
