%% This file save the interesting data and converts to the correct units 
% and calculates the difference between the actual value and the working 
% point of the parameter.

% Working point
p_dh_L = 4.58;
p_c_L = 4.64;
x_L = [4.64;4.62;4.59;4.57;4.54;4.52;4.49;4.47;4.44;4.42];
choke_L = 0.6;


%% Generate rich input to the choke position [0,1]

% For simulation time = 318, period 3 sec
data = rand(53);
for i = 1:53
    vec(1,3*i-2:3*i) = 0.45+0.3*data(i); 
end
for i = 54:70
    vec(1,3*i-2:3*i) = 0.6;
end
time = 1:210;
choke_input = timeseries(vec,time);

set_param('simdata_generator/switch', 'sw', '1')
sim('simdata_generator_rich')

% choke_sim_delta = ChokeSim - choke_wp;
choke_opening = choke_input; 
choke_pressure = C2Sim*10^(-5) - p_c_L;
pipe_pressure_sim_delta = CopperPipeSim*10^(-5) - x_L;
dh_pressure_sim_delta = P2Sim*10^(-5)-p_dh_L;

savename = ['ident_rich_wp.mat'];
save(savename, 'choke_pressure', 'piston_velocity_ref', ...
    'pipe_pressure_sim_delta', 'dh_pressure_sim_delta')
save('choke_opening.mat', 'choke_opening')

clearvars -except piston_velocity_ref_to_sim p_dh_L p_c_L x_L choke_L piston_vel_wp

%% Generate rich input to the choke position [0,1]

% For simulation time = 318, period 3 sec
data = rand(53);
for i = 1:53
    vec(1,3*i-2:3*i) = 0.45+0.3*data(i); 
end
for i = 54:70
    vec(1,3*i-2:3*i) = 0.6;
end
time = 1:210;
choke_input = timeseries(vec,time);
choke_opening = choke_input; 

set_param('simdata_generator/switch', 'sw', '0')
sim('simdata_generator_rich')
% choke_sim_delta = ChokeSim - choke_wp;
choke_pressure = C2Sim*10^(-5) - p_c_L;
% piston_velocity_ref = piston_velocity_ref_to_sim;
pipe_pressure_sim_delta = CopperPipeSim*10^(-5) - x_L;
dh_pressure_sim_delta = P2Sim*10^(-5)-p_dh_L;
savename = ['test_rich_wp.mat'];
save(savename, 'choke_pressure', 'piston_velocity_ref', ...
    'pipe_pressure_sim_delta', 'dh_pressure_sim_delta')
save('choke_opening.mat', 'choke_opening')