%% This file creates the mathematical model based of a certain model and 
% saves it as a state space model A, B, C, D. 

% Uncomment if script is not used %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
order = 7;
max_order = 20;

ident_set = 'ident_wp.mat';
test_set = 'test_wp.mat';

id_data = extract_data(ident_set);
test_data = extract_data(test_set);

% % Earlier version, p_dh included in black-box modeling
% U = [id_data(:,1) id_data(:,2)];
% Y = id_data(:,3:end);
% U_test = [test_data(:,1) test_data(:,2)];
% Y_test = test_data(:,3:end);

% Updated version, p_dh NOT included in black-box modeling (Attempt on grey-box modeling)
U = [id_data(:,1) id_data(:,2)];
Y = id_data(:,3:end-2);
U_test = [test_data(:,1) test_data(:,2)];
Y_test = test_data(:,3:end-2);


[A,B,C,D,CF,F,~]=dsr(Y,U,max_order,1,max_order,1,order);
%      where C     = CF*inv(F),       (Kalman gain, K =inv(A)*C and C=A*K),
%      Delta = E(e_t e_t^T) = F*F',   (Innovations noise covariance
%      matrix). 
E = CF*inv(F);
K = inv(A)*CF*inv(F);           %% Kalman gain
R = F*F';                       %% Noise covariance matrix

savename = ['model_order_', num2str(order), '.mat'];
save(savename, 'A','B','C','D', 'K', 'R'); 
% save(savename, 'A','B','C','D', 'E', 'K', 'R'); 