function disturbance_estimator(block)
%   Copyright 2003-2010 The MathWorks, Inc.
setup(block);

%endfunction

function setup(block)

load('dimensions.mat');
% Dim. of estimated disturbance series: dim_v_d


% Register number of ports
block.NumInputPorts  = 1;
block.NumOutputPorts = 1;

% Setup port properties to be inherited or dynamic
block.SetPreCompInpPortInfoToDynamic;
block.SetPreCompOutPortInfoToDynamic;

%%Referansesignal - P_dh,ref
%   block.InputPort(1).Dimensions        = 1;  
  block.InputPort(1).Dimensions        = 2;
  block.InputPort(1).DirectFeedthrough = false;

  
block.OutputPort(1).Dimensions       = mpc_horizon;

% Register parameters
block.NumDialogPrms     = 0;

% Register sample times: (Same as MPC)
block.SampleTimes = [-1 0];

% Specify the block simStateCompliance. The allowed values are:
%    'DefaultSimState', < Same sim state as a built-in block
block.SimStateCompliance = 'DefaultSimState';


block.RegBlockMethod('PostPropagationSetup',    @DoPostPropSetup);
block.RegBlockMethod('InitializeConditions', @InitializeConditions);
block.RegBlockMethod('Outputs', @Outputs);
block.RegBlockMethod('Update', @Update);

%end setup

function DoPostPropSetup(block)
block.NumDworks = 1;
load('dimensions.mat')
    
  block.Dwork(1).Name = 'd';
  block.Dwork(1).Dimensions = mpc_horizon;
  block.Dwork(1).DatatypeID = 0;
  block.Dwork(1).Complexity = 'Real';

%endfunction

function InitializeConditions(block)


%end InitializeConditions


function Outputs(block)

block.OutputPort(1).Data =  block.Dwork(1).Data;

%end Outputs
function Update(block)
load('disturbance_data.mat')
% x0 = [block.InputPort(1).data; block.Dwork(2).Data(2)];
x0 = block.InputPort(1).data;

y = lsim(sys_dist, zeros(mpc_horizon,1), t, x0');
block.Dwork(1).Data = y';

%end Update


%%
%% Terminate:
%%   Functionality    : Called at the end of simulation for cleanup
%%   Required         : Yes
%%   C-MEX counterpart: mdlTerminate
%%
function Terminate(block)

%end Terminate