function [id_set] = extract_data_choke(data_set, choke_opening)
%Function to extract useful data
%   This function extracts desired data from a dataset and saves it in a 
%   new dataset, id_set. 
load(data_set)

% p_dh_L = 4.43;
p_c_L = 4.21;
x_L = [4.61;4.56;4.54;4.51;4.54;4.50;4.45;4.45;4.4;4.38];
% choke_opening = C2;
% choke_opening.Data = choke_opening.Data - p_c_L;

pipe_pressure = CopperPipe;
for i = 1:10
    pipe_pressure.Data(:,i) = pipe_pressure.Data(:,i) - x_L(i);
end
piston_velocity = pistonVelocity;


% choke_pressure = choke_sim;
% pipe_pressure_sim_delta = pipe_pressure_sim;
% dh_pressure_sim_delta = dh_pressure_sim;


lengths = [length(choke_opening) length(piston_velocity.data) ...
    length(pipe_pressure.data)];
min_length = min(lengths);

id_set = [choke_opening(1:min_length) ...
    piston_velocity.data(1:min_length) ...
    pipe_pressure.data(1:min_length,:)];

end
