%% This file save the interesting data and converts to the correct units 
% and calculates the difference between the actual value and the working 
% point of the parameter.

% Working point
p_dh_L = 4.43;
p_c_L = 4.21;
x_L = [4.61;4.56;4.54;4.51;4.54;4.50;4.45;4.45;4.4;4.38];
choke_L = 45; %(Degrees opening)


%% Generate rich input to the choke position [0,1]

% For simulation time = 318, period 3 sec
temp = 40;
for i = 1:53
    vec(1,3*i-2:3*i) = temp+0.0057;
    temp = temp+0.0057
end
temp = 0.75;
for i = 1:53
    vec(1,3*(53+i)-2:3*(53+i)) = temp-(i*0.0057);
end
time = 1:318;
choke_input = timeseries(vec,time);

sim('simdata_generator')

% choke_sim_delta = ChokeSim - choke_wp;
choke_opening = choke_input; 
choke_pressure = C2Sim*10^(-5) - p_c_L;
pipe_pressure_sim_delta = CopperPipeSim*10^(-5) - x_L;
dh_pressure_sim_delta = P2Sim*10^(-5)-p_dh_L;

savename = ['ident_wp.mat'];
save(savename, 'choke_pressure', 'piston_velocity_ref', ...
    'pipe_pressure_sim_delta', 'dh_pressure_sim_delta')
save('choke_opening.mat', 'choke_opening')

clearvars -except piston_velocity_ref_to_sim p_dh_L p_c_L x_L choke_L piston_vel_wp

%% Generate rich input to the choke position [0,1]

% For simulation time = 318, period 3 sec
temp = 0.75;
for i = 1:53
    vec(1,3*i-2:3*i) = temp-(i*0.0057);
end
temp = 0.45;
for i = 1:53
    vec(1,3*(53+i)-2:3*(53+i)) = temp+(i*0.0057);
end
time = 1:318;
choke_input = timeseries(vec,time);
choke_opening = choke_input; 

sim('simdata_generator')
% choke_sim_delta = ChokeSim - choke_wp;
choke_pressure = C2Sim*10^(-5) - p_c_L;
% piston_velocity_ref = piston_velocity_ref_to_sim;
pipe_pressure_sim_delta = CopperPipeSim*10^(-5) - x_L;
dh_pressure_sim_delta = P2Sim*10^(-5)-p_dh_L;
savename = ['test_wp.mat'];
save(savename, 'choke_pressure', 'piston_velocity_ref', ...
    'pipe_pressure_sim_delta', 'dh_pressure_sim_delta')
save('choke_opening.mat', 'choke_opening')