%% This file creates the mathematical model based of a certain model and 
% saves it as a state space model A, B, C, D. 

% Uncomment if script is not used %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
order = 10;
max_order = 30;

ident_set = '140514-IDset.mat';
test_set = '140514-VERset.mat';

load('initVariables_0506.mat')

% Create VER-set
ident_set = '140514-VERset.mat';
chokecharTest = chokecharTest-2;
choke_opening = chokecharTest(42001:62001);

id_data = extract_data(ident_set, choke_opening);

% Create ID-set
test_set = '140514-IDset.mat';
choke_opening = (-1)*choke_opening;
choke_opening = choke_opening + 88;

test_data = extract_data(test_set, choke_opening);

% % Earlier version, p_dh included in black-box modeling
% U = [id_data(:,1) id_data(:,2)];
% Y = id_data(:,3:end);
% U_test = [test_data(:,1) test_data(:,2)];
% Y_test = test_data(:,3:end);

% Updated version, p_dh NOT included in black-box modeling (Attempt on grey-box modeling)
U = [id_data(:,1) id_data(:,2)];
Y = id_data(:,3:end-1);
U_test = [test_data(:,1) test_data(:,2)];
Y_test = test_data(:,3:end-1);


[A,B,C,D,CF,F,~]=dsr(Y,U,max_order,1,max_order,1,order);
%      where C     = CF*inv(F),       (Kalman gain, K =inv(A)*C and C=A*K),
%      Delta = E(e_t e_t^T) = F*F',   (Innovations noise covariance
%      matrix). 
E = CF*inv(F);
K = inv(A)*CF*inv(F);           %% Kalman gain
R = F*F';                       %% Noise covariance matrix



sysd = ss(A, B, C, D, 0.01);
end_time = (length(U_test)-1)/100;
t = 0:0.01:end_time;
Y_p = lsim(sysd, U_test, t);
figure(1); plot(Y_p)
figure(2); plot(Y)

savename = ['310514-model_order_', num2str(order), '.mat'];
save(savename, 'A','B','C','D', 'K', 'R'); 
% save(savename, 'A','B','C','D', 'E', 'K', 'R'); 