%% Calculate gains for the observer

% disturbance frequency (angular)
omega = 2*pi*0.2;

% pipe length
l = 900;

% linear friction
F1 = 0.24;

% fluid density
rho = 1000;

% speed of sound
c = 850;

% difference between cross section areas of upper and lower rod
A2 = pi*(0.5*25E-3)^2-pi*(0.5*22E-3)^2;

% desired poles of the observer
p = [-40+20*1i, -40-20*1i];

[p1, p2, G] = kernelsolver(p, omega, l, F1, rho, c, A2);